=== debian/changelog ===
spectral (0.0~2019.11.12+dfsg-2build1) focal; urgency=medium

  * Rebuild against new libcmark0.29.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Feb 2020 19:31:27 +0100

spectral (0.0~2019.11.12+dfsg-2) unstable; urgency=medium

  * Add versioned dependencies for all the qml modules, based on a report
    from a user with older modules (but newer qt libraries) installed.
  * Fix FTBFS on big-endian machines such as s390x.

 -- Andres Salomon <dilinger@debian.org>  Fri, 07 Feb 2020 03:48:11 +0000

spectral (0.0~2019.11.12+dfsg-1) unstable; urgency=low

  * Initial release (closes: #941800).

 -- Andres Salomon <dilinger@debian.org>  Fri, 29 Nov 2019 21:48:50 +0000
