=== debian/control ===
Source: spectral
Section: net
Priority: optional
Maintainer: Andres Salomon <dilinger@debian.org>
Build-Depends: debhelper (>= 12.0~),
               cmake,
               qtbase5-dev (>= 5.12),
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
               libqt5svg5-dev,
               qt5keychain-dev,
               qtdeclarative5-dev,
               cmark,
               libcmark-dev,
               libolm-dev (>= 3.0)
Standards-Version: 4.4.1.1
Homepage: https://gitlab.com/b0/spectral

Package: spectral
Architecture: any
Depends: ${shlibs:Depends},
         qml-module-qtmultimedia (>= 5.12),
         qml-module-qtquick-controls2 (>= 5.12),
         qml-module-qtquick-layouts (>= 5.12),
         qml-module-qt-labs-settings (>= 5.12),
         qml-module-qt-labs-platform (>= 5.12),
         qml-module-qt-labs-qmlmodels (>= 5.12),
         qml-module-qtgraphicaleffects (>= 5.12),
         fonts-noto-color-emoji,
         ${misc:Depends}
Description: Glossy desktop chat client for the Matrix protocol
 Spectral is a glossy cross-platform QT-based chat client for the
 Matrix protocol. Matrix is an open, decentralized, federated
 communications protocol with support for chat rooms, IM, etc.
