=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

get-orig-source:
	uscan  --force-download --repack --verbose

# TODO: Once the libquotient library stabilizes, we'll want to use a
# a shared library by setting USE_INTREE_LIBQMC to false. But we're
# not there yet.
#override_dh_auto_configure:
#	dh_auto_configure -- -DUSE_INTREE_LIBQMC=0
