=== debian/watch ===
version=4
opts="dversionmangle=auto, repacksuffix=+dfsg" \
    https://gitlab.com/b0/spectral/-/tags \
    .*/spectral-(\d[\d.]*)\.tar\.gz
