## spectral 0.0~2020.03.28

=== include/libQuotient/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,9 @@
 set(API_VERSION "0.6")
 project(Quotient VERSION "${API_VERSION}.0" LANGUAGES CXX)
 
-option(QUOTIENT_INSTALL_EXAMPLE "install qmc-example application" ON)
+option(${PROJECT_NAME}_INSTALL_TESTS "install quotest (former qmc-example) application" ON)
+# https://github.com/quotient-im/libQuotient/issues/369
+option(${PROJECT_NAME}_ENABLE_E2EE "end-to-end encryption (E2EE) support" OFF)
 
 include(CheckCXXCompilerFlag)
 if (NOT WIN32)
@@ -52,25 +54,29 @@
     endforeach ()
 endif()
 
-find_package(Qt5 5.9 REQUIRED Network Gui Multimedia)
+find_package(Qt5 5.9 REQUIRED Network Gui Multimedia Test)
 get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
 
-if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
-        AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
-    add_subdirectory(3rdparty/libQtOlm EXCLUDE_FROM_ALL)
-    include_directories(3rdparty/libQtOlm)
-    if (NOT DEFINED USE_INTREE_LIBQOLM)
-        set (USE_INTREE_LIBQOLM 1)
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
+            AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
+        add_subdirectory(3rdparty/libQtOlm EXCLUDE_FROM_ALL)
+        include_directories(3rdparty/libQtOlm)
+        if (NOT DEFINED USE_INTREE_LIBQOLM)
+            set (USE_INTREE_LIBQOLM 1)
+        endif ()
     endif ()
-endif ()
-if (NOT USE_INTREE_LIBQOLM)
-    find_package(QtOlm 0.1.0 REQUIRED)
-    if (NOT QtOlm_FOUND)
-        message( WARNING "libQtOlm not found; configuration will most likely fail.")
-        message( WARNING "Make sure you have installed libQtOlm development files")
-        message( WARNING "as a package or checked out the library sources in lib/.")
-        message( WARNING "See also BUILDING.md")
+    if (NOT USE_INTREE_LIBQOLM)
+        find_package(QtOlm 0.1.0 REQUIRED)
+        if (NOT QtOlm_FOUND)
+            message( WARNING "libQtOlm not found; configuration will most likely fail.")
+            message( WARNING "Make sure you have installed libQtOlm development files")
+            message( WARNING "as a package or checked out the library sources in lib/.")
+            message( WARNING "See also BUILDING.md")
+        endif ()
     endif ()
+else ()
+    message( WARNING "End-to-end encryption (E2EE) support is turned off.")
 endif ()
 
 if (GTAD_PATH)
@@ -108,18 +114,20 @@
     endif ()
 endif ()
 find_package(Git)
-if (USE_INTREE_LIBQOLM)
-    message( STATUS "Using in-tree libQtOlm")
-    if (GIT_FOUND)
-        execute_process(COMMAND
-            "${GIT_EXECUTABLE}" rev-parse -q HEAD
-            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
-            OUTPUT_VARIABLE QTOLM_GIT_SHA1
-            OUTPUT_STRIP_TRAILING_WHITESPACE)
-        message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
-    endif (GIT_FOUND)
-else ()
-    message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    if (USE_INTREE_LIBQOLM)
+        message( STATUS "Using in-tree libQtOlm")
+        if (GIT_FOUND)
+            execute_process(COMMAND
+                "${GIT_EXECUTABLE}" rev-parse -q HEAD
+                WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
+                OUTPUT_VARIABLE QTOLM_GIT_SHA1
+                OUTPUT_STRIP_TRAILING_WHITESPACE)
+            message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
+        endif (GIT_FOUND)
+    else ()
+        message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
+    endif ()
 endif ()
 message( STATUS "=============================================================================" )
 message( STATUS )
@@ -129,6 +137,7 @@
     lib/networkaccessmanager.cpp
     lib/connectiondata.cpp
     lib/connection.cpp
+    lib/ssosession.cpp
     lib/logging.cpp
     lib/room.cpp
     lib/user.cpp
@@ -148,6 +157,7 @@
     lib/events/roomtombstoneevent.cpp
     lib/events/roommessageevent.cpp
     lib/events/roommemberevent.cpp
+    lib/events/roompowerlevelsevent.cpp
     lib/events/typingevent.cpp
     lib/events/receiptevent.cpp
     lib/events/reactionevent.cpp
@@ -158,6 +168,7 @@
     lib/events/directchatevent.cpp
     lib/events/encryptionevent.cpp
     lib/events/encryptedevent.cpp
+    lib/events/roomkeyevent.cpp
     lib/jobs/requestdata.cpp
     lib/jobs/basejob.cpp
     lib/jobs/syncjob.cpp
@@ -193,6 +204,7 @@
         ${ABS_GTAD_PATH} --config ${CSAPI_DIR}/gtad.yaml --out ${CSAPI_DIR}
             ${FULL_CSAPI_SRC_DIR}
             old_sync.yaml- room_initial_sync.yaml- # deprecated
+            search.yaml- # current GTAD is limited in handling move-only data
             sync.yaml- # we have a better handcrafted implementation
         WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/lib
         SOURCES ${FULL_CSAPI_DIR}/gtad.yaml
@@ -218,9 +230,12 @@
     endif()
 endif()
 
-set(example_SRCS examples/qmc-example.cpp)
+set(tests_SRCS tests/quotest.cpp)
 
 add_library(${PROJECT_NAME} ${lib_SRCS} ${api_SRCS})
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    target_compile_definitions(${PROJECT_NAME} PUBLIC ${PROJECT_NAME}_E2EE_ENABLED)
+endif()
 set_target_properties(${PROJECT_NAME} PROPERTIES
     VERSION "${PROJECT_VERSION}"
     SOVERSION ${API_VERSION}
@@ -235,11 +250,16 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 )
-target_link_libraries(${PROJECT_NAME} QtOlm Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)
-
-add_executable(qmc-example ${example_SRCS})
-target_link_libraries(qmc-example Qt5::Core Quotient)
-configure_file(Quotient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc @ONLY NEWLINE_STYLE UNIX)
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    target_link_libraries(${PROJECT_NAME} QtOlm)
+endif()
+target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)
+
+set(TEST_BINARY quotest)
+add_executable(${TEST_BINARY} ${tests_SRCS})
+target_link_libraries(${TEST_BINARY} Qt5::Core Qt5::Test ${PROJECT_NAME})
+
+configure_file(${PROJECT_NAME}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc @ONLY NEWLINE_STYLE UNIX)
 
 # Installation
 
@@ -255,15 +275,15 @@
 # NB: SameMajorVersion doesn't really work yet, as we're within 0.x trail.
 # Maybe consider jumping the gun and releasing 1.0, as semver advises?
 write_basic_package_version_file(
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
     COMPATIBILITY SameMajorVersion
 )
 
 export(PACKAGE ${PROJECT_NAME})
 export(EXPORT ${PROJECT_NAME}Targets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Targets.cmake")
-configure_file(cmake/QuotientConfig.cmake
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfig.cmake"
+configure_file(cmake/${PROJECT_NAME}Config.cmake
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
     COPYONLY
 )
 
@@ -271,21 +291,21 @@
 install(EXPORT ${PROJECT_NAME}Targets
         FILE ${PROJECT_NAME}Targets.cmake DESTINATION ${ConfigFilesLocation})
 
-install(FILES cmake/QuotientConfig.cmake
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
+install(FILES cmake/${PROJECT_NAME}Config.cmake
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
     DESTINATION ${ConfigFilesLocation}
 )
-install(EXPORT_ANDROID_MK QuotientTargets DESTINATION share/ndk-modules)
+install(EXPORT_ANDROID_MK ${PROJECT_NAME}Targets DESTINATION share/ndk-modules)
 
 if (WIN32)
     install(FILES mime/packages/freedesktop.org.xml DESTINATION mime/packages)
 endif (WIN32)
 
-if (QUOTIENT_INSTALL_EXAMPLE)
-    install(TARGETS qmc-example RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-endif (QUOTIENT_INSTALL_EXAMPLE)
+if (${PROJECT_NAME}_INSTALL_TESTS)
+    install(TARGETS ${TEST_BINARY} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+endif ()
 
 if (UNIX AND NOT APPLE)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
             DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 endif()
