=== debian/changelog ===
spectral (0.0~2020.03.28-1) unstable; urgency=low

  * New git snapshot release. 

 -- Andres Salomon <dilinger@debian.org>  Thu, 02 Apr 2020 21:29:47 +0000

spectral (0.0~2020.02.09-1) unstable; urgency=low

  * New git snapshot release.
  * Drop +dfsg from the version, re-introduce the app metadata, & update
    debian/copyright to document it. It was previously GFDL, now CC.
  * Document new upstream location.
  * Drop all the applied patches.

 -- Andres Salomon <dilinger@debian.org>  Fri, 06 Mar 2020 22:21:02 +0000
