## spectral 0.0~git20210114.30028a2

=== CMakeLists.txt ===
--- 
+++ 
@@ -143,6 +143,8 @@
     src/spectraluser.h
     src/trayicon.h
     src/userlistmodel.h
+    src/publicroomlistmodel.h
+    src/userdirectorylistmodel.h
     src/utils.h
     src/accountlistmodel.cpp
     src/controller.cpp
@@ -155,6 +157,8 @@
     src/spectraluser.cpp
     src/trayicon.cpp
     src/userlistmodel.cpp
+    src/publicroomlistmodel.cpp
+    src/userdirectorylistmodel.cpp
     src/utils.cpp
     src/main.cpp
 )
@@ -238,8 +242,8 @@
     install(FILES linux/${IDENTIFIER}.appdata.xml
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
             )
-    file(GLOB spectral_icons icons/hicolor/*-apps-spectral.png)
+    file(GLOB spectral_icons icons/hicolor/*-apps-org.eu.encom.spectral.png)
     ecm_install_icons(ICONS ${spectral_icons}
-                      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
-                      )
+            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
+    )
 endif(LINUX)
