=== debian/changelog ===
spectral (0.0~git20210114.30028a2-3) unstable; urgency=low

  * Drop package building, replace with an empty Spectral package.
  * Depend on Neochat, which is maintained by KDE and is a fork of
    Spectral. We will remove Spectral from Debian after bookworm
    is released, as Spectral is no longer developed upstream.

 -- Andres Salomon <dilinger@debian.org>  Fri, 20 May 2022 16:28:58 +0000

spectral (0.0~git20210114.30028a2-2) unstable; urgency=medium

  * Drop some libQuotient residue from debian/copyright and debian/watch.
  * Revert 30028a27 from upstream git; it was causing hangs w/ 100% cpu
    when used with libQuotient 0.6.

 -- Andres Salomon <dilinger@debian.org>  Tue, 26 Jan 2021 00:30:45 +0000

spectral (0.0~git20210114.30028a2-1) unstable; urgency=low

  * New git snapshot release.
  * Break SortFilterProxyModel out of the source orig tarball, since
    it is coming from a different upstream. Uscan will now handle
    it automatically.
  * Stop building against the bundled libQuotient, and instead build
    against libquotient-dev in Debian. FTBFS fixes are included due to
    upstream using a libQuotient development snapshot.

 -- Andres Salomon <dilinger@debian.org>  Mon, 25 Jan 2021 07:34:05 +0000
