=== debian/control ===
Source: spectral
Section: net
Priority: optional
Maintainer: Andres Salomon <dilinger@debian.org>
Build-Depends: debhelper (>= 12.0~),
Standards-Version: 4.4.1.1
Homepage: https://gitlab.com/b0/spectral

Package: spectral
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, neochat
Description: Transitional dummy package
 This is a transitional dummy package, it can be safely removed.
 Spectral is no longer developed, and Neochat replaces it.
