=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_build:
	@echo hi mom!

override_dh_auto_configure:
#	test -d include/SortFilterProxyModel && rmdir include/SortFilterProxyModel
#	ln -s ../SortFilterProxyModel include/SortFilterProxyModel
#	dh_auto_configure -- -DUSE_INTREE_LIBQMC=0

#override_dh_clean:
#	dh_clean
#	rm -f include/SortFilterProxyModel || true
#	mkdir -p include/SortFilterProxyModel

#get-orig-source:
#	uscan  --force-download --repack --verbose
