## spectral 1.0

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 1.0
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <m.seilmayer@hzdr.de>
Description: Fourier and Hilbert transforms are utilized to perform several types
             of spectral analysis on the supplied data. Also fragmented and
             irregularly spaced data can be processed. A user friendly interface
             helps to interpret the results.
License: GPL-2
Depends: rasterImage, R (>= 2.15.0)
LazyData: TRUE
RoxygenNote: 5.0.1
LinkingTo: Rcpp
Imports: Rcpp
Packaged: 2016-09-13 07:20:39 UTC; ms5760
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2016-09-13 11:45:38
