## spectral 1.3

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 1.3
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <m.seilmayer@hzdr.de>
Description: Fourier and Hilbert transforms are utilized to perform several
    types of spectral analysis on the supplied data. Fragmented and irregularly
    spaced data can be processed in terms of Lomb-Scargle method. Both,
    FFT as well as LOMB methods take multivariate data. A user friendly
    interface helps to interpret the results.
License: GPL-2
Depends: rasterImage,lattice, R (>= 2.15.0)
LazyData: TRUE
RoxygenNote: 6.1.1
NeedsCompilation: no
Packaged: 2019-06-03 06:46:04 UTC; martinseilmayer
Repository: CRAN
Date/Publication: 2019-06-03 11:30:07 UTC
