## spectral 2.0

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 2.0
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <martin.seilmayer@gmail.com>
Description: On discrete data spectral analysis is performed by Fourier and Hilbert
    transforms as well as with model based analysis called Lomb-Scargle method.
    Fragmented and irregularly spaced data can be processed in almost all methods. Both,
    FFT as well as LOMB methods take multivariate data and return standardized PSD. 
    For didactic reasons an analytical approach for deconvolution of noise spectra and 
    sampling function is provided.
    A user friendly interface helps to interpret the results.
License: GPL-2
Depends: rasterImage,lattice,RhpcBLASctl,pbapply, R (>= 3.5.0)
LazyData: FALSE
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2021-03-28 17:29:07 UTC; martinseilmayer
Repository: CRAN
Date/Publication: 2021-03-29 09:30:02 UTC
